﻿using System;
using System.Text;

/// @author  Vesa Lappalainen, Antti-Jussi Lakanen
/// @version 2020
/// 
/// <summary>
/// Aliohjelmien kutsuja ja paremetrilistoja
/// </summary>
public class Kutsut
{
    /// <summary>
    /// Alustukset ja kutsut.
    /// </summary>
    /// <param name="args"></param>
    public static void Main(string[] args)
    {
        StringBuilder muuttuvaJono;
        String jono;
        int i;
        double d;
        int[] luvut;
        double[] t;
        bool onko;

        muuttuvaJono = new StringBuilder("kissa istuu ja istuu puussa");
        onko = PoistaJononViimeinen(muuttuvaJono, "istuu"); // Tehtävä 1 (a)
        luvut = new int[] { 4, 2, 4, 5, 1 };
        i = LaskeMaara(luvut, 4); // Tehtävä 1 (b)
        jono = TuplaaMerkki("Janne", 'a'); // Tehtävä 1 (c)
        t = LuoTaulukko(10, 3.0, 1.1);   // Tehtävä 1 (d)
                                         // Luo-taulukko-funktion idea:
                                         // se luo taulukon, jossa 10 lukua (1. parametri)
                                         // aloittaen luvusta 3.0 (2. parametri)
                                         // kasvattaen seuraavia lukuja aina 1.1:llä (3. parametri)
                                         // Tässä tuloksena tulisi taulukko: 3.0, 4.1, 5.2, ...

        d = Keskiarvo(t); // Tehtävä 1 (e)
    }

    /// <summary>
    /// Tuplaa jonosta halutun merkin kaikki ilmentymät.
    /// </summary>
    /// <param name="jono">Jono, jossa tuplataan etsittävä kirjain</param>
    /// <param name="tuplattava">Merkki, joka halutaan tuplata.</param>
    /// <returns>Jono, jossa merkit tuplana.</returns>
    public static String TuplaaMerkki(String jono, char tuplattava)
    {
        return jono;
    }

    /// <summary>
    /// Aliohjelma poistaa StringBuilder-jonosta annetun
    /// merkkijonon viimeisen ilmentymän StringBuilder-jonossa.
    /// Huomaa, että aliohjelma muuttaa alkuperäistä jonoa.
    /// </summary>
    /// <param name="jono">Jono, josta poistetaan.</param>
    /// <param name="poistettava">Poistettava merkkijono</param>
    /// <returns>Palauttaa true, jos jonosta
    /// poistettiin yksikin ilmentymä. Muuten
    /// palautetaan false.</returns>
    public static bool PoistaJononViimeinen(StringBuilder jono, string poistettava)
    {
        return true;
    }


    /// <summary>
    /// Lasketaan taulukon alkoiden keskiarvo
    /// </summary>
    /// <param name="t">taulukko luvuista joiden keskiarvo lasketaan</param>
    /// <returns>lukujen keskiarvo</returns>
    public static double Keskiarvo(double[] t)
    {
        return 0.0;
    }


    /// <summary>
    /// Luodaan reaalilukutaulukko, jossa maara-parametrin verran lukuja
    /// alkaen luvusta aloitus ja kukin luku on edellistä lisays verran suurempi.
    /// </summary>
    /// <param name="maara">montako lukua taulukkoon luodaan</param>
    /// <param name="aloitus">mistä luvusta aloitetaan</param>
    /// <param name="lisays">paljonko lisätään kerralla</param>
    /// <returns>Taulukko jossa luodut luvut</returns>
    public static double[] LuoTaulukko(int maara, double aloitus, double lisays)
    {
        return null;
    }



    /// <summary>
    /// Lasketaan monta etsittava-lukua on taulukossa luvut
    /// </summary>
    /// <param name="luvut">taulukko josta lukuja etsitään</param>
    /// <param name="etsittava">mitä lukuja etsitään</param>
    /// <returns>löytyneiden lukujen lukumäärä</returns>
    public static int LaskeMaara(int[] luvut, int etsittava)
    {
        return 0;
    }


}
